> ## Documentation Index
> Fetch the complete documentation index at: https://docs.compasslabs.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Repay Loans

> This endpoint allows users to repay a portion or the entirety of their borrowed
tokens on the Aave platform.

By repaying borrowed amounts, users can improve their health factor, which is a
measure of the safety of their loan position. A higher health factor reduces the
risk of liquidation, ensuring a more secure borrowing experience. The endpoint
requires specifying the chain and the details of the repayment transaction,
including the amount and the asset to be repaid.
                    <Info>
                    **Required Allowances**

                        In order to make this transaction, token allowances need to be set for the following contracts.

                     - `AaveV3Pool`
                    </Info>
                



## OpenAPI

````yaml /v1/combined_spec.json post /v1/aave/repay
openapi: 3.1.0
info:
  title: Compass API
  description: Compass Labs DeFi API
  version: 0.0.1
servers:
  - url: https://api.compasslabs.ai
    description: Production server
security:
  - ApiKeyAuth: []
paths:
  /v1/aave/repay:
    post:
      tags:
        - Aave V3
      summary: Repay Loans
      description: >-
        This endpoint allows users to repay a portion or the entirety of their
        borrowed

        tokens on the Aave platform.


        By repaying borrowed amounts, users can improve their health factor,
        which is a

        measure of the safety of their loan position. A higher health factor
        reduces the

        risk of liquidation, ensuring a more secure borrowing experience. The
        endpoint

        requires specifying the chain and the details of the repayment
        transaction,

        including the amount and the asset to be repaid.
                            <Info>
                            **Required Allowances**

                                In order to make this transaction, token allowances need to be set for the following contracts.

                             - `AaveV3Pool`
                            </Info>
                        
      operationId: v1_aave_repay
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AaveRepayRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TransactionResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            from compass_api_sdk import CompassAPI, models


            with CompassAPI(
                api_key_auth="<YOUR_API_KEY_HERE>",
            ) as compass_api:

                res = compass_api.aave_v3.aave_repay(token="USDC", amount="0.2", interest_rate_mode=models.InterestRateMode.VARIABLE, chain=models.AaveRepayRequestChain.BASE, sender="0x3254f3b1918637ba924e3F18968Cb74219974b63", on_behalf_of="0x3254f3b1918637ba924e3F18968Cb74219974b63", estimate_gas=True)

                # Handle response
                print(res)
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { CompassApiSDK } from "@compass-labs/api-sdk";

            const compassApiSDK = new CompassApiSDK({
              apiKeyAuth: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await compassApiSDK.aaveV3.aaveRepay({
                token: "USDC",
                amount: "0.2",
                interestRateMode: "variable",
                onBehalfOf: "0x3254f3b1918637ba924e3F18968Cb74219974b63",
                chain: "base",
                sender: "0x3254f3b1918637ba924e3F18968Cb74219974b63",
              });

              console.log(result);
            }

            run();
components:
  schemas:
    AaveRepayRequest:
      properties:
        action_type:
          type: string
          const: AAVE_REPAY
          title: Action Type
          default: AAVE_REPAY
        token:
          type: string
          title: Token
          description: The symbol of the underlying asset to repay..
          examples:
            - WETH
          default: USDC
        amount:
          anyOf:
            - type: number
              exclusiveMinimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount
          description: The amount of the asset to repay
          examples:
            - 150.5
          default: '0.2'
        interest_rate_mode:
          $ref: '#/components/schemas/InterestRateMode'
          description: The interest rate mode to repay
          examples:
            - stable
          default: variable
        on_behalf_of:
          anyOf:
            - type: string
            - type: 'null'
          title: On Behalf Of
          description: The address on behalf of whom the supply is made
          default: '0x3254f3b1918637ba924e3F18968Cb74219974b63'
          examples:
            - '0x3254f3b1918637ba924e3F18968Cb74219974b63'
        chain:
          type: string
          enum:
            - arbitrum
            - base
            - ethereum
          title: Chain
          default: base
          examples:
            - base
        sender:
          type: string
          title: Sender
          description: The address of the transaction sender.
          examples:
            - '0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B'
          default: '0x3254f3b1918637ba924e3F18968Cb74219974b63'
        estimate_gas:
          type: boolean
          title: Estimate Gas
          description: >-
            Determines whether to estimate gas costs for transactions, also
            verifying that the transaction can be successfully executed.
          default: true
      type: object
      required:
        - token
        - amount
        - interest_rate_mode
        - chain
        - sender
      title: AaveRepayRequest
      default:
        chain: base
        sender: '0x3254f3b1918637ba924e3F18968Cb74219974b63'
        token: USDC
        amount: '0.2'
        interest_rate_mode: variable
        on_behalf_of: '0x3254f3b1918637ba924e3F18968Cb74219974b63'
      required_allowances:
        - AaveV3Pool
    TransactionResponse:
      properties:
        transaction:
          anyOf:
            - $ref: '#/components/schemas/UnsignedTransaction'
            - $ref: '#/components/schemas/UserOperationResponse'
          title: Transaction
          description: >-
            The unsigned transaction data. User must sign and broadcast to
            network.
      type: object
      required:
        - transaction
      title: TransactionResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    InterestRateMode:
      type: string
      enum:
        - stable
        - variable
      title: InterestRateMode
      description: |-
        On AAVE there are 2 different interest modes.

        A stable (but typically higher rate), or a variable rate.
    UnsignedTransaction:
      properties:
        chainId:
          type: string
          title: Chainid
          description: The chain id of the transaction
        data:
          type: string
          title: Data
          description: The data of the transaction
        from:
          type: string
          title: From
          description: The sender of the transaction
        gas:
          anyOf:
            - type: string
            - type: 'null'
          title: Gas
          description: The gas of the transaction
        to:
          type: string
          title: To
          description: The recipient of the transaction
        value:
          type: string
          title: Value
          description: The value of the transaction
        nonce:
          type: string
          title: Nonce
          description: The nonce of the address
        maxFeePerGas:
          type: string
          title: Maxfeepergas
          description: The max fee per gas of the transaction
        maxPriorityFeePerGas:
          type: string
          title: Maxpriorityfeepergas
          description: The max priority fee per gas of the transaction
      type: object
      required:
        - chainId
        - data
        - from
        - gas
        - to
        - value
        - nonce
        - maxFeePerGas
        - maxPriorityFeePerGas
      title: UnsignedTransaction
      example:
        chainId: '0x2105'
        data: >-
          0x1688f0b900000000000000000000000029fcb43b46531bca003ddc8fcb67ffe91900c762000000000000000000000000000000000000000000000000000000000000006000000000000000000000000000000000000000000000000000000000675f4a3d
        from: '0x4A83b4413CF41C3244027e1590E35a0F48403F0c'
        gas: '0x7a120'
        maxFeePerGas: '0x59682f00'
        maxPriorityFeePerGas: '0x3b9aca00'
        nonce: '0x5'
        to: '0x4e1DCf7AD4e460CfD30791CCC4F9c8a4f820ec67'
        value: '0x0'
    UserOperationResponse:
      properties:
        to:
          type: string
          title: To
          description: The target contract address for the operation
        data:
          type: string
          title: Data
          description: The calldata for the operation
        value:
          type: string
          title: Value
          description: The ETH value to send with the operation
      type: object
      required:
        - to
        - data
        - value
      title: UserOperationResponse
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        Your Compass API Key. Get your key
        [here](https://www.compasslabs.ai/dashboard).

````